#	@(#)bsd.lib.mk	8.1 (Berkeley) 6/8/93

.if exists(${.CURDIR}/../Makefile.inc)
.include "${.CURDIR}/../Makefile.inc"
.endif

RANLIB_T =	-t

.if defined(BOOTSTRAP)
. if !defined(HOST_BIN)
.  if ${MACHINE} == "mips"
AR_CF =	cq
.   if exists(${CROSS_BIN}/nm)
NM ?=	${CROSS_BIN}/nm
.   endif
LORDER ?=	NM=${NM} ${TOOLS_BIN}/lorder
.  endif
.  if exists(${CROSS_BIN}/tsort)
TSORT ?=	${CROSS_BIN}/tsort
.  endif
.  if exists(${CROSS_BIN}/ranlib)
RANLIB_T =
.  endif
AINC +=		-I${BSDSRCDIR}/lib/libc/${MACHINE}
. else
INSTALL_DIR =	${TOOLS_DIR}/lib
AINC +=		-DNO_AENT=1
AR_CF =	cq
. endif

NM ?=	nm
.endif

TSORT ?=	tsort

AR_CF ?=	cTq
LORDER ?=	lorder
NROFF ?=	nroff

LIBDIR?=	/usr/lib
LINTLIBDIR?=	/usr/libdata/lint
LIBGRP?=	bin
LIBOWN?=	bin
LIBMODE?=	444

STRIP?=	-s

BINGRP?=	bin
BINOWN?=	bin
BINMODE?=	555

INSTALL_DIR ?=	${DESTDIR}${LIBDIR}

.MAIN: all

# prefer .s to a .c, add .po, remove stuff not used in the BSD libraries
.SUFFIXES:
.SUFFIXES: .out .o .po .s .c .f .y .l .8 .7 .6 .5 .4 .3 .2 .1 .0 .m4

.8.0 .7.0 .6.0 .5.0 .4.0 .3.0 .2.0 .1.0:
	${NROFF} -man ${.IMPSRC} > ${.TARGET}

.c.o:
	${CC} ${CFLAGS} -c ${.IMPSRC} 
	${LD} -x -r ${.TARGET}
	mv a.out ${.TARGET}

.c.po:
	${CC} -p ${CFLAGS} -c ${.IMPSRC} -o ${.TARGET}
	@${LD} -X -r ${.TARGET}
	@mv a.out ${.TARGET}

.s.o:
	${CPP} -E ${CFLAGS:M-[ID]*} ${AINC} ${.IMPSRC} | \
	    ${AS} -o ${.TARGET}
	${LD} -x -r ${.TARGET}
	mv a.out ${.TARGET}

.s.po:
	${CPP} -E -DPROF ${CFLAGS:M-[ID]*} ${AINC} ${.IMPSRC} | \
	    ${AS} -o ${.TARGET}
	@${LD} -X -r ${.TARGET}
	@mv a.out ${.TARGET}

MANALL=	${MAN1} ${MAN2} ${MAN3} ${MAN4} ${MAN5} ${MAN6} ${MAN7} ${MAN8}
manpages: ${MANALL}

.if !defined(NOPROFILE)
_LIBS=lib${LIB}.a lib${LIB}_p.a
.else
_LIBS=lib${LIB}.a
.endif

all: ${_LIBS} # llib-l${LIB}.ln
.if !defined(NOMAN)
all: ${MANALL}
.endif

OBJS+=	${SRCS:R:S/$/.o/g}

lib${LIB}.a:: ${OBJS}
	@echo building standard ${LIB} library
	rm -f lib${LIB}.a
	${AR} ${AR_CF} lib${LIB}.a `${LORDER} ${OBJS} | ${TSORT}` ${LDADD}
	${RANLIB} lib${LIB}.a

POBJS+=	${OBJS:.o=.po}
lib${LIB}_p.a:: ${POBJS}
	@echo building profiled ${LIB} library
	@rm -f lib${LIB}_p.a
	@${AR} ${AR_CF} lib${LIB}_p.a `${LORDER} ${POBJS} | ${TSORT}` ${LDADD}
	${RANLIB} lib${LIB}_p.a

llib-l${LIB}.ln: ${SRCS}
	${LINT} -C${LIB} ${CFLAGS} ${.ALLSRC:M*.c}

.if !target(clean)
clean:
	rm -f ${OBJS}
	rm -f ${POBJS}
	rm -f a.out Errs errs mklog ${CLEANFILES} \
	    profiled/*.o lib${LIB}.a lib${LIB}_p.a llib-l${LIB}.ln
.endif

.if !target(cleandir)
cleandir:
	rm -f ${OBJS}
	rm -f ${POBJS}
	rm -f a.out Errs errs mklog ${CLEANFILES} \
	    profiled/*.o lib${LIB}.a lib${LIB}_p.a llib-l${LIB}.ln
	rm -f ${MANALL} ${.CURDIR}/tags .depend
.endif

.if !target(depend)
depend: .depend
.depend: ${SRCS}
	${MKDEP} ${CFLAGS:M-[ID]*} ${AINC} ${.ALLSRC}
	@(TMP=/tmp/_depend$$$$; \
	    sed -e 's/^\([^\.]*\).o *:/\1.o \1.po:/' < .depend > $$TMP; \
	    mv $$TMP .depend)
.endif

.if !target(install)
.if !target(beforeinstall)
beforeinstall:
.endif

realinstall: beforeinstall
	${RANLIB} lib${LIB}.a
	[ -d ${INSTALL_DIR} ] || mkdir ${INSTALL_DIR}
	install -c -o ${LIBOWN} -g ${LIBGRP} -m ${LIBMODE} lib${LIB}.a \
	    ${INSTALL_DIR}
	${RANLIB} ${RANLIB_T} ${INSTALL_DIR}/lib${LIB}.a
.if !defined(NOPROFILE)
	${RANLIB} lib${LIB}_p.a
	install -c -o ${LIBOWN} -g ${LIBGRP} -m ${LIBMODE} \
	    lib${LIB}_p.a ${INSTALL_DIR}
	${RANLIB} ${RANLIB_T} ${INSTALL_DIR}/lib${LIB}_p.a
.endif
#	install -c -o ${LIBOWN} -g ${LIBGRP} -m ${LIBMODE} \
#	    llib-l${LIB}.ln ${DESTDIR}${LINTLIBDIR}
.if defined(LINKS) && !empty(LINKS)
	@set ${LINKS}; \
	while test $$# -ge 2; do \
		l=${INSTALL_DIR}/$$1; \
		shift; \
		t=${INSTALL_DIR}/$$1; \
		shift; \
		echo $$t -\> $$l; \
		rm -f $$t; \
		ln $$l $$t; \
	done; true
.endif

install: afterinstall
afterinstall: realinstall
.if !defined(NOMAN)
afterinstall: maninstall
.endif
.endif

.if !target(lint)
lint:
.endif

.if !target(tags)
tags: ${SRCS}
	-ctags -f /dev/stdout ${.ALLSRC:M*.c} | \
	    sed "s;\${.CURDIR}/;;" > ${.CURDIR}/tags
.endif

.include <bsd.man.mk>
.if !target(obj)
.if defined(NOOBJ)
obj:
.else
obj:
	@cd ${.CURDIR}; rm -rf obj; \
	here=`pwd`; dest=/usr/obj/`echo $$here | sed 's,/usr/src/,,'`; \
	echo "$$here -> $$dest"; ln -s $$dest obj; \
	if test -d /usr/obj -a ! -d $$dest; then \
		mkdir -p $$dest; \
	else \
		true; \
	fi;
.endif
.endif
