# for compile 4.4BSD using NetBSD-1.1 tools

## set env eg. MAKESYSPATH=`cd ../../00TOOL/mk; pwd`
## key word BOOTSTRAP bootstrap compilation on diff arch.
##          HOST_BIN generate cross binary, install into TOOLS_BIN

BSDSRCDIR ?=	/usr/src/csrg-d4

DESTD0 ?=	/usr/obj/b44-installed

U_MACHINE !=	uname -m
.if ${U_MACHINE} == "DEC" || ${U_MACHINE} == "pmax"
MACHINE =	mips
.endif
.if ${U_MACHINE} == "sun3"
# MACHINE =	hp300
# MACHINE =	luna68k
.endif

TARGET_ENV ?=	4.4BSD-${MACHINE}
HOST_ENV !=	echo `uname -s`-${MACHINE}
TARGET_TOOLS_DIR ?=	/usr/local/tools

.if ${HOST_ENV} == ${TARGET_ENV}
BSDINSTDIR ?=	${DESTD0}.self-${MACHINE}
TOOLS_DIR ?=	${TARGET_TOOLS_DIR}
DESTDIR ?=	${BSDINSTDIR}
.else
BOOTSTRAP =	yes
BSDINSTDIR ?=	${DESTD0}.${HOST_ENV}
TOOLS_DIR ?=	/usr/local/cross/${MACHINE}-bsd44f
. if !defined(HOST_BIN)
DESTDIR ?=	${BSDINSTDIR}
. endif
.endif

TOOLS_BIN =	${TOOLS_DIR}/bin
TARGET_TOOLS_BIN =	${TARGET_TOOLS_DIR}/bin
HOST_CC ?=	gcc
HOST_CFLAGS ?=	-O2

.if ${HOST_ENV} == ${TARGET_ENV}
TOOLS_DIR ?=	${TARGET_TOOLS_DIR}
TOOLS_BIN ?=	${TARGET_TOOLS_BIN}
INST_DIR ?=	${BSDINSTDIR}
.else
. if defined(HOST_BIN)
INST_DIR ?=	${TOOLS_DIR}
. endif
INST_DIR ?=	${BSDINSTDIR}
.endif

.if defined(BOOTSTRAP)
NOPROFILE =	yes
NOPIC =		yes
NOMAN =		yes
NOTAGS =	yes

. if ${MACHINE} == "mips"
CROSS_BIN ?=	/usr/local/cross/mips-dec-bsd4.4/bin
. else
CROSS_BIN ?=	/usr/bin
. endif

. if ${MACHINE} == "luna68k" || ${MACHINE} == "hp300"
CFLAGS +=	-D${MACHINE}
HOST_CFLAGS +=	-D${MACHINE}
. endif

. if !defined(HOST_BIN)
CC =		${CROSS_BIN}/gcc

.  if exists(${TOOLS_BIN}/ld)
LD =		${TOOLS_BIN}/ld
.  else
LD =		${CROSS_BIN}/ld
.  endif

.  if exists(${TOOLS_BIN}/as)
AS =	${TOOLS_BIN}/as
.  elif exists(${CROSS_BIN}/as)
AS =	${CROSS_BIN}/as
.  endif

.  if exists(${CROSS_BIN}/ar)
AR =	${CROSS_BIN}/ar
RANLIB =	${CROSS_BIN}/ranlib
.  endif

.  if exists(${CROSS_BIN}/yacc)
YACC ?=	${CROSS_BIN}/yacc
.  endif
.  if exists(${CROSS_BIN}/lex)
LEX ?=	${CROSS_BIN}/lex
.  endif

.  if exists(${CROSS_BIN}/../../usr/libexec/cpp)
CPP =	${CROSS_BIN}/../../usr/libexec/cpp
.  endif
.  if exists(/usr/libexec/cpp)
CPP =	/usr/libexec/cpp
.  endif

.  if exists(${CROSS_BIN}/strip)
STRIP_CMD ?=	${CROSS_BIN}/strip
.  endif
. endif
.endif

STRIP_CMD ?=	strip
STRIP_ENV ?=	STRIP=${STRIP_CMD}	# for install -s
##
STRIP_ENV =	STRIP=			# XXX
STRIP =					# install's -s flag

.if !defined(DESTDIR) || ${DESTDIR} != ""
. if defined(BOOTSTRAP)
.  if !defined(HOST_BIN)
CFLAGS +=	-nostdinc -I${BSDINSTDIR}/usr/include
INST_LIBDIR ?=	${BSDINSTDIR}/usr/lib

.   if ${MACHINE} == "sparc" || ${MACHINE} == "luna68k" || ${MACHINE} == "hp300"
LDFLAGS +=	-B${TOOLS_BIN}/
.   endif
LDFLAGS +=	-B${BSDINSTDIR}/usr/lib/ -L${BSDINSTDIR}/usr/lib
LDADD_C ?=	-L${BSDINSTDIR}/usr/lib -lc
.  else
LDADD_C ?=	-L${TOOLS_DIR}/lib -lc
.  endif
. else
CFLAGS +=	-nostdinc -I${BSDINSTDIR}/usr/include
LDFLAGS +=	-B${BSDINSTDIR}/usr/lib/ -L${BSDINSTDIR}/usr/lib
LDADD_C ?=	-L${BSDINSTDIR}/usr/lib -lc
. endif
.endif

MKDEP =	mkdep
# MKDEP =	${HOST_CC_ENV} /bin/cat ${BSDSRCDIR}/usr.bin/mkdep/mkdep.sh |\
#   sed 's,^cc\( -M \),${HOST_CC}\1,' |\
#   sh -s --

# .if ${MACHINE} == "mips"
# USE_OLD_ROFF =	yes			# broken C++ global constructor
# .endif

.if !defined(BOOTSTRAP) && defined(USE_OLD_ROFF)
NROFF ?=	/usr/old/bin/nroff
EQN ?=		/usr/old/bin/eqn
INDXBIB ?=	/usr/old/bin/indxbib
REFER ?=	/usr/old/bin/refer
TBL ?=		/usr/old/bin/tbl
.else
NROFF ?=	nroff
EQN ?=		eqn
INDXBIB ?=	indxbib
REFER ?=	refer
TBL ?=		tbl
.endif

